#####################################################################
# mk_csv_real.pl
# μ¶ͽ¬ǡ(csv)
#
#  Υǡ
#  Useage ./mk_csv_real.pl TABLE_FILE AREA_NUM WF_NUM -t YYMMDDHHmm\n YYMMDDHHmm:JST
#  -t ץǻ򤷤ʤϡǿǽ
#
#####################################################################
use Time::Local;

$TABLE = $ARGV[0];
$AREA_NUM = $ARGV[1];
$POINT_NUM = $ARGV[2];
require "$TABLE";

use Getopt::Long;
use Time::Local;
$Getopt::Long::ignorecase=undef;
GetOptions('t=s');

#######    ###################
if( $opt_t ne "" && length($opt_t)!=10 ){
   die "Usage ./mk_mk_csv_real.pl TABLE_FILE AREA_NUM WF_NUM -t YYMMDDHHmm\n YYMMDDHHmm:JST\n";
}elsif( length( $opt_t ) == 10 ){
    $jyear4=1*substr($opt_t,0,2)+2000;
    $jyear2=1*substr($opt_t,0,2);
    $jmonth =1*substr($opt_t,2,2);
    $jday =1*substr($opt_t,4,2);
    $jhour=1*substr($opt_t,6,2);
    $jmin=1*substr($opt_t,8,2);
    $jsec=0;
    $now_t = timelocal($jsec,$jmin,$jhour,$jday,$jmonth-1,$jyear4);
}else{
    $now_t = time();
}


#----  ߻ -----  
($nsec,$nmin,$nhour,$nmday,$nmon,$nyear,$nwday,$nyday,$nisdist) = localtime($now_t);
$nmon++;
$nyear4 = $nyear + 1900;
$nyear2 = $nyear4 % 100;
$now_ymd = sprintf("%02d%02d%02d",$nyear2,$nmon,$nmday);
$now_ymdhm = sprintf("%02d%02d%02d%02d%02d",$nyear2,$nmon,$nmday,$nhour,$nmin);

$now_m3 = $now_t-3*3600;
($psec,$pmin,$phour,$pmday,$pmon,$pyear,$pwday,$pyday,$pisdist) = localtime($now_m3);
$pmon++;
$pyear4 = $pyear + 1900;
$pyear2 = $pyear4 % 100;
$now_m3_ymd = sprintf("%02d%02d%02d",$pyear2,$pmon,$pmday);
$now_m3_ymdhm = sprintf("%02d%02d%02d",$pyear2,$pmon,$pmday,$phour,$pmin);

######################################
## Open Input data 
######################################
print "INDATA = $REAL_DSET_File\n";
open(IN,"<$REAL_DSET_File");
  @indata = <IN>;
close(IN);

######################################
## Open Output data
######################################
open(OUT,">$CSVFile_Today");

print "OUT=$CSVFile_Today\n";

################################
#  ǿ¶λ         ##
################################
#-- 
$Nyy=1990; $Nmm=1; $Ndd=1; $Nhh=0; $Nmn=0;

foreach $line ( @indata ) {
  chomp($line);
  @buf = split(/,/,$line);
  if ( $buf[5] ne "" and $buf[6] ne "" ) {
     $Nyy = 2000+$buf[0]; $Nmm = $buf[1]; $Ndd = $buf[2]; $Nhh = $buf[3]; $Nmn = $buf[4];
  }
} 
print "Y=$Nyy,M=$Nmm,D=$Ndd,H=$Nhh,MN=$Nmn\n";
$now_obs_time = timelocal(0,$Nmn,$Nhh,$Ndd,$Nmm-1,$Nyy);

#--- ߤ3ʾŤ¶ǿʤСǡ򤷤ʤ
# öȤȤޤ20070912, yokotsuka)
$t_hani = $now_obs_time - $now_m3;
#if ( $t_hani < 0 ) { exit;}
if ( $t_hani < 0 ) { 
   $Nyy = $nyear4;
   $Nmm = $nmon;
   $Ndd = $nmday;
   $Nhh = $nhour;
   if ( $nmin >= 0 and $nmin < 30 ) { 
        $Nmn = 0; 
   } else {
        $Nmn = 30;
   }
   $now_obs_time = timelocal(0,$Nmn,$Nhh,$Ndd,$Nmm-1,$Nyy);
}


#--- 6
($sec_6,$min_6,$hour_6,$mday_6,$mon_6,$year_6,$wday_6,$yday_6,$isdist_6) = 
                                                  localtime($now_obs_time-6*3600);
$mon_6++;
$year4_6 = $year_6 +1900;
$year2_6 = $year4_6 % 100;
$obs_m6_ymdhm = sprintf("%02d%02d%02d%02d%02d",$year2_6,$mon_6,$mday_6,$hour_6,$min_6);

#--- 24.5ָλ
($sec_1d,$min_1d,$hour_1d,$mday_1d,$mon_1d,$year_1d,$wday_1d,$yday_1d,$isdist_1d) =
                                                  localtime($now_obs_time+(24*3600)+1800);
$mon_1d++;
$year4_1d = $year_1d +1900;
$year2_1d = $year4_1d % 100;
$obs_p1d_ymdhm = sprintf("%02d%02d%02d%02d%02d",$year2_1d,$mon_1d,$mday_1d,$hour_1d,$min_1d);

#---  ǡ
@buf = ();
foreach $line ( @indata ) {
  chomp($line);
  @buf = split(/,/,$line);
  $ymdhm = sprintf("%02d%02d%02d%02d%02d",$buf[0],$buf[1],$buf[2],$buf[3],$buf[4]);
  if ( $ymdhm <= $obs_m6_ymdhm ) {
    next;
  } elsif ( $ymdhm > $obs_p1d_ymdhm ) {
    last;
  } else {
    printf OUT ("%04d/%02d/%02d %02d:%02d,",$Nyy,$buf[1],$buf[2],$buf[3],$buf[4]);
    printf OUT "$buf[5],$buf[6],$buf[7],$buf[8],$buf[9],$buf[10],$buf[11],$buf[12],$buf[13],$buf[14],$buf[15],$buf[16]\n";
  }
}

close(OUT);

exit;
