#! /bin/csh
#####################################################################
# ZEXEC_STAT.csh
#
#  Useage ZEXEC_STAT.csh 0      <--- ̾ 
#  Useage ZEXEC_STAT.csh YYMMDDHH      <-- ǯ
#
#####################################################################

cd /data/online/exec_platform_std

### TABLE SETTING ###
set TABLE1=STAT_PARAM_a02_w001.tab
set TABLE2=STAT_PARAM_a02_w007.tab
set TABLE3=STAT_PARAM_a02_w010.tab

#####################################################################
if($1 == "") then
  set YY = ( `date '+%y' -d Y` )
  set MM = ( `date '+%m' -d Y` )
  set DD = ( `date '+%d' -d Y` )
  set HH = ( `date '+%H'` )
  set YMDH = ${YY}${MM}${DD}${HH}
else
 set YMDH = $argv[1]
 set YY = ( `echo ${YMDH} | cut -c1-2` )
 set MM = ( `echo ${YMDH} | cut -c3-4` )
 set DD = ( `echo ${YMDH} | cut -c5-6` )
 set HH = ( `echo ${YMDH} | cut -c7-8` )
endif
echo $YMDH

set YM  = ${YY}${MM}
#set BYMDH = ${YY}${MM}${DD}06
set BYMDH = ${YY}${MM}${DD}07
set LOGDIR = ./log/c${YM}/${YMDH}
mkdir -p ${LOGDIR}

#===============================================================================
# 1. statͽ¬ͽ¬κ
#===============================================================================

### ͽ¬ ###
perl ./exec_stat1.pl ${TABLE1} -t $BYMDH > &! ${LOGDIR}/stat1_${YMDH}.log
perl ./exec_stat1.pl ${TABLE2} -t $BYMDH > &! ${LOGDIR}/stat1_${YMDH}.log
perl ./exec_stat1.pl ${TABLE3} -t $BYMDH > &! ${LOGDIR}/stat1_${YMDH}.log

### ͽ¬ ###
perl ./exec_stat2.pl ${TABLE1} -t $YMDH  > &! ${LOGDIR}/stat2_${YMDH}.log
perl ./exec_stat2.pl ${TABLE2} -t $YMDH  > &! ${LOGDIR}/stat2_${YMDH}.log
perl ./exec_stat2.pl ${TABLE3} -t $YMDH  > &! ${LOGDIR}/stat2_${YMDH}.log
#===============================================================================

#--------------------------------------------------------------------
# 1. make statistic error ( every 30min.)
#--------------------------------------------------------------------
perl ./mk_pic_csv_errtime.pl ${TABLE1}
perl ./mk_pic_csv_errtime_tm.pl ${TABLE1}
perl ./mk_pic_csv_errtime.pl ${TABLE3}
perl ./mk_pic_csv_errtime_tm.pl ${TABLE3}

#--------------------------------------------------------------------
# 2. make histgram
#--------------------------------------------------------------------
perl ./mk_ctc_pic_errdist.pl ${TABLE1}
perl ./mk_ctc_pic_errdist_tm.pl ${TABLE1}
perl ./mk_ctc_pic_errdist.pl ${TABLE3}
perl ./mk_ctc_pic_errdist_tm.pl ${TABLE3}


#--------------------------------------------------------------------
# 3. FTP
#--------------------------------------------------------------------
echo 3.FTP PUT
#csh ./ftpput_stat.csh





exit;
