#!/usr/local/bin/perl
#####################################################################
# exec_stat1.pl (ͽ¬)
#  -> stat1_p200_YYMMDDHH.csv ͽ¬
#  -> hist1_p200_YYMMDDHH.csv ʬ
#
# 2007.08.15
# 2007.08.16 rwf.parm
#####################################################################
use Time::Local;
use lib "./lib_perl";
use Tms_v9;
use Stat_v15;
use Getopt::Long;
$Getopt::Long::ignorecase=undef;
GetOptions('t=s');
#GetOptions('t=s','b=i');

require "$ARGV[0]";  #ե

$ymdh = $opt_t; ($yy,$mm,$dd,$hh) = $ymdh =~/(\d\d)(\d\d)(\d\d)(\d\d)/;
#$hh = "06";  # 6hͽ¬ǡͽ¬θ
$hh = "07";  # 7hͽ¬ǡͽ¬θ
$mn = 0;
$bnum = 30;  # 30 ̤ͽ¬

#$idir = "../data/fcs";
$odir = sprintf("%s",$TMPDIR);
$odir_1 = sprintf("%s/c%02d%02d",$TMPDIR,$yy,$mm);
system "mkdir -p $odir_1";

$wf = $POINT_NUM;

#############################
##--  ϥե  -- ##
#############################
# STAT #
$ofile1 = sprintf("%s/stat1_a%s_p%s.csv",$odir,$AREA_NUM,$POINT_NUM);
$ofile1_1 = sprintf("%s/stat1_a%s_p%s_%s.csv",$odir_1,$AREA_NUM,$POINT_NUM,$ymdh);
printf " -> $ofile1\n";
open(OUT1,">$ofile1");
printf OUT1 "KTN,     ME,    MAE,   RMSE,   CORR,    CAPA, DNUM,     NME,   NMAE,  NRMSE\n";

# HIST #
$ofile2 = sprintf("%s/hist1_a%s_p%s.csv",$odir,$AREA_NUM,$POINT_NUM);
$ofile2_1 = sprintf("%s/hist1_a%s_p%s_%s.csv",$odir_1,$AREA_NUM,$POINT_NUM,$ymdh);
printf " -> $ofile2\n";

#-- 1̤
($yy1,$mm1,$dd1,$hh1,$mn1) = Tms_v9::ctime_m(-24,$yy,$mm,$dd,$hh,$mn);

############################################
##-- 1̤ꡢͽ¬եɤ߹  --##
############################################
for ( $i=0; $i<$bnum; $i++ ){
 @FDATE=(); 
 @FWP=(); 

 #--- 1̤
 $updt_hh = -1*($i*24);
 ($uyy,$umm,$udd,$uhh,$umn) = Tms_v9::ctime_m($updt_hh,$yy1,$mm1,$dd1,$hh1,$mn1);

 $ymdh = sprintf "%02d%02d%02d%02d",$uyy,$umm,$udd,$uhh;
 #printf "**********************\n";
 printf "** [$i, $ymdh ] **\n";
 #printf "**********************\n";

 $udate = sprintf "%02d%02d%02d%02d%02d",$uyy,$umm,$udd,$uhh,$umn;
 #--- Open :Forecast Data File
 $ifile1 = sprintf("%s/c%02d%02d/%sf%s_20%s00.csv",$FCSDIR,$uyy,$umm,$AREA_NUM,$POINT_NUM,$ymdh);
   printf "fcs <- $ifile1\n";
   if(!-e $ifile1){ printf "NO FILE : $ifile1\n"; next; }
   @FDATE = Tms_v9::SUB_Platform_emdate($ifile1,$udate,0);
   @FWP   = Tms_v9::SUB_Platform_emdata($ifile1,$udate,0,1);

   #############################
   #--- ¬ǡɤ߹--##
   #############################
   @OWP=();
   foreach $kt (0..$#FDATE){
    ($d_yy,$d_mm,$d_dd,$d_hh,$d_mn)=split(/,/,$FDATE[$kt]); 
     $obfile = sprintf("%s/c%02d%02d/%ss%s_20%02d%02d%02d%02d%02d.csv",$OBSDIR,$d_yy,$d_mm,$AREA_NUM,$POINT_NUM,$d_yy,$d_mm,$d_dd,$d_hh,$d_mn);
     printf "obs <- $obfile\n";
     if(!-e $obfile){ 
        printf "NO FILE : $obfile\n"; 
        $tmpdat="-999.9";
        push(@OWP,$tmpdat);
        next;
     } else {
        @buf = ();
        @odata=();
        open(OB,"<$obfile") ;
          @buf = <OB>;
        close(OB);
        foreach $line ( @buf ){
          chomp $line;
          $s1 = substr($line,0,1);
          if( $s1 eq "#" ){ next; }
          @odata = split(/,/,$line);
          $odata[0] %= 100;
          $odate  = sprintf("%02d,%02d,%02d,%02d,%02d",$odata[0],$odata[1],$odata[2],$odata[3],$odata[4]);
          print "## DATE:$odate OBS:$odata[5] FDATE:$FDATE[$kt] FCS:$FWP[$kt]\n";
          $odata[5] = 1*$odata[5];
          if ( $odata[5] < -999 ) {
            $odata_MW = -999.9;
          } else {
            $odata_MW = sprintf("%.2f",($odata[5]/1000.0)); #kW -> MW #<- ǡkWñ
          }
          push(@OWP,$odata_MW); # $odata_MWMWñ
        }
     }

#   @CAPA  = Tms_v9::emdata($obfile,$udate,0,2);
   } 

   $capa = $POWER_MAX;
   foreach $g (0..$#FDATE){
     push(@{$KTFDATE->{$g}},$FDATE[$g]);
     push(@{$KTFWP->{$g}},$FWP[$g]);
     if($OWP[$g] <= -900 ){
       $owp  = -999.9;
     }else{ 
       $owp  = $OWP[$g];
     }
     push(@{$KTOWP->{$g}},$owp);
     push(@{$KTCAPA->{$g}},$capa);

     if($owp > -900){
       $err  = $FWP[$g] - $OWP[$g];
       $aerr = abs($err);
       #printf "$g, $FDATE[$g], $OWP[$g],$FWP[$g],  $CAPA[$g]\n";
       if($err != 0){ $err /= $capa; }else{ $err = 0; }
     }else{
       $err  = -999.9;
       $aerr = -999.9;
     }
     push(@{$KTERR->{$g}},$err);
     push(@{$KTAERR->{$g}},$aerr);
     #printf "%03d,%s,%7.2f,%7.2f\n",$g,$FDATE[$g],$OWP[$g],$FWP[$g];
   } #" $g

} #i

# OUTPUT #
@TMERR=();
foreach $g (0..42*2){  #" KT=0褫KT=84ޤ( 30min )  
 #-----------------------------------------------------------------------
 # STAT
 #-----------------------------------------------------------------------
 ($b,$r,$c) = Stat_v15::stat3(@{$KTOWP->{$g}},@{$KTFWP->{$g}});
 $mae  = Stat_v15::mean(@{$KTAERR->{$g}});
 if ( $b < -900 ) {
   $nb = -999.900;
 } else {
   $nb   = $b/$capa;
 }
 if ( $mae < -900 ) {
   $nmae = -999.900;
 } else {
   $nmae = $mae/$capa;
 }
 if ( $r < -900 ) {
   $nr = -999.900;
 } else {
   $nr   = $r/$capa;
 }
 printf OUT1 "%03d,%7.3f,%7.3f,%7.3f,%7.3f, %7.2f,%5d, %7.3f,%7.3f,%7.3f\n",
              $g,$b,$mae,$r,$c,$capa,scalar(@{$KTOWP->{$g}}),$nb,$nmae,$nr;
 printf      "%03d,%7.3f,%7.3f,%7.3f,%7.3f, %7.2f,%5d, %7.3f,%7.3f,%7.3f\n",
              $g,$b,$mae,$r,$c,$capa,scalar(@{$KTOWP->{$g}}),$nb,$nmae,$nr;
 #-----------------------------------------------------------------------

 #-----------------------------------------------------------------------
 # HIST 
 #-----------------------------------------------------------------------
 if($g >= 18*2 and $g < 42*2){ #" ϰϡKT=27-9褫KT=51-9ޤ
   push(@TMERR,@{$KTERR->{$g}});
 } #" if
} #" $g
close(OUT1);

#------------------------#
# histgram 
#------------------------#
$min=-1.0;$max=1.0;$bin=20*2; #" 20:5%
#------------------------#
#if($g == 0){
(@LABEL) = Stat_v15::histp_v3(1,0,1,$min,$max,$bin,@TMERR);
&out_array($ofile2,0,"NUM",@LABEL,"MEAN","SIGMA");
#} 
$mean = Stat_v15::mean  (@TMERR); #" mean  : ʿ͡ʡ
$sigma= Stat_v15::stddev(@TMERR); #" sigma : ɸкʡ
(@ARSLT) = Stat_v15::histp_v3(0,0,1,$min,$max,$bin,@TMERR);
#&out_array($ofile2,1,'TM',@ARSLT);
&out_array($ofile2,1,'TM',@ARSLT,$mean,$sigma);

#---  ϥǡΥХåå׽
$cmd = "cp -p $ofile1 $ofile1_1"; 
system("$cmd");
$cmd = "cp -p $ofile2 $ofile2_1";
system("$cmd"); 

#-----------------------------------------------------------------------


#=====================================================================
# 
#=====================================================================
sub out_array{
my $ofile = shift @_;
my $add   = shift @_;
my @DATA  = @_;
my $g;

### ե ###
if($ofile ne 0){
 if($add == 0){ open(OT," >$ofile"); } #" printf " ->  $ofile\n";}
 else         { open(OT,">>$ofile"); } #" printf " ->> $ofile\n";}

 printf OT "$DATA[0],";
 foreach $g (1..$#DATA-1){ printf OT "$DATA[$g],"; }
 printf OT "$DATA[$#DATA]\n";
 close(OT);
}

### ɸ ###
else{
 printf "$DATA[0],";
 foreach $g (1..$#DATA-1){ printf "$DATA[$g],"; }
 printf "$DATA[$#DATA]\n";
}

} #" sub
#=====================================================================
exit;
