#!/usr/bin/perl
#==============================
# NEDO Platform page 
#   1st.2007.03.23 T.Yokotsuka
#   2nd.2007.07.11 T.Yokotsuka
#------------------------------
#=====================================================
#        M A I N
#=====================================================

use Time::Local;
use CGI;
require './Nedo_platform.ph';
require './Platform_lib.pl';

$query = new CGI;
$AW_CODE = $query->param( "AW" );
$AREA_NUM = $query->param( "AREA" );
$WF_NUM = $query->param( "WF_NUM" );
$S_FLG = $query->param( "onoff" );
@GAIBU = $query->param( "gsystem" );

$CNT_NUM = 111;
$HTML_TAB = sprintf("wf_html_base.tab");

open(OSHU,">$Shudan_flg_file");
 print OSHU "FG,$S_FLG\n";
 print OSHU "GS,@GAIBU\n";
close(OSHU);

#--- DATA PATH SETTING
$DAT_PATH = $DAT_PATH_std;
if ( $S_FLG == 2 ) { $DAT_PATH = $DAT_PATH_KANI; }

#-----------------
#    OutPut
#-----------------
if ( $S_FLG == 1) {

  ####   Write Header  ####
  print "Content-Type: text/html\n\n";

  open (IN,"<$HTML_TAB");
  while ($line = <IN>) {

    if ( $line =~ /##POINT_SELECT_PART##/ ) {
        Write_Select_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
    } elsif (( $line =~ /#WF_NUM#/ )or( $line =~ /#AW_CODE#/ )or( $line =~ /#AREA_NUM#/ ) or ( $line =~ /#S_FLG#/ )) {
        $line =~ s/#AW_CODE#/$AW_CODE/g;
        $line =~ s/#AREA_NUM#/$AREA_NUM/g;
        $line =~ s/#WF_NUM#/$WF_NUM/g;
        $line =~ s/#S_FLG#/$S_FLG/g;
        print "$line";
    } elsif ( $line =~ /##CONTENTS_DISPLAY_PART##/ ) {
        Write_Content_WF($AW_CODE,$AREA_NUM,$WF_NUM,502,$WF_POINT_TAB,$DAT_PATH,$S_FLG);
    } elsif ( $line =~ /##SHUUDAN_F##/ ) {
	$line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">ʽġ<\/font>/g;
        print "$line";
    } else {
        print "$line";
    }

  }
  close(IN);

} elsif ( $S_FLG == 2) {

  ####   Write Header  ####
  print "Content-Type: text/html\n\n";

  open (IN,"<$HTML_TAB");
  while ($line = <IN>) {

    if ( $line =~ /##POINT_SELECT_PART##/ ) {
        Write_Select_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
    } elsif (( $line =~ /#WF_NUM#/ )or( $line =~ /#AW_CODE#/ )or( $line =~ /#AREA_NUM#/ )or($line =~ /#S_FLG#/ )) {
        $line =~ s/#AW_CODE#/$AW_CODE/g;
        $line =~ s/#AREA_NUM#/$AREA_NUM/g;
        $line =~ s/#WF_NUM#/$WF_NUM/g;
        $line =~ s/#S_FLG#/$S_FLG/g;
        print "$line";
    } elsif ( $line =~ /##CONTENTS_DISPLAY_PART##/ ) {
        Write_Content_WF($AW_CODE,$AREA_NUM,$WF_NUM,503,$WF_POINT_TAB,$DAT_PATH,$S_FLG);
    } elsif ( $line =~ /##SHUUDAN_F##/ ) {
        $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">ʴʰס<\/font>/g;
        print "$line";
    } else {
        print "$line";
    }

  }
  close(IN);

} else {
  ####   Write Header  ####
  print "Content-Type: text/html\n\n";

  open (IN,"<$HTML_TAB");
  while ($line = <IN>) {

    if ( $line =~ /##POINT_SELECT_PART##/ ) {
        Write_Select_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
    } elsif (( $line =~ /#WF_NUM#/ )or( $line =~ /#AW_CODE#/ )or( $line =~ /#AREA_NUM#/ )or ($line =~ /#S_FLG#/ )) {
        $line =~ s/#AW_CODE#/$AW_CODE/g;
        $line =~ s/#AREA_NUM#/$AREA_NUM/g;
        $line =~ s/#WF_NUM#/$WF_NUM/g;
        $line =~ s/#S_FLG#/$S_FLG/g;
        print "$line";
    } elsif ( $line =~ /##CONTENTS_DISPLAY_PART##/ ) {
        Write_Content_WF($AW_CODE,$AREA_NUM,$WF_NUM,504,$WF_POINT_TAB,$DAT_PATH,$S_FLG);
    } elsif ( $line =~ /##SHUUDAN_F##/ ) {
        $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">̾<\/font>/g;
        print "$line";
    } else {
        print "$line";
    }

  }
  close(IN);
}


exit;

#=====================================================
#        E N D   M A I N
#=====================================================

