#! /usr/bin/perl
use Time::Local;

###############################
####      File Delete      ####
###############################

$TABLE = "./ZEXEC_DELETE.tab";

$TT=time;

open(IN,"$TABLE");
while($line=<IN>) {
   @dat=();
   next if ($line =~ /^#/);
   chomp($line);
   @dat = split(/,/,$line);

   $deldir{$dat[0]} = $dat[1];
   $KeepDay{$dat[0]} = $dat[2];
   $KeepSec{$dat[0]} = $TT - $KeepDay{$dat[0]}*86400;
#   print "deldir=$deldir{$dat[0]}\n";

}
close(IN);

foreach $NO ( keys %deldir ) {

  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($KeepSec{$NO});
  $mon++;
  $year+=1900;
  $year2=$year%100;

  $cYYMM = sprintf("c%02d%02d",$year2,$mon);

  $deldel = sprintf("%s/%s",$deldir{$NO},$cYYMM);
#  print "deldel=$deldel\n";

  @flist = ();
  opendir (DLDIR,"$deldel");
  @flist =grep {!m/^(\.|\.\.)$/g} readdir(DLDIR);
  closedir(DLDIR);

  foreach $chklist(@flist) {
    $ckfile = sprintf("%s/%s",$deldel,$chklist);
    if ( -e $ckfile) {
        $fktime = (stat($ckfile))[9];
        if ($KeepSec{$NO} >= $fktime) {
            unlink $ckfile;
            print "delfile=$ckfile\n";
        }
    }
  }

} 
exit;

