#####################################################################
# mk_csv_real_yetm.pl
# μ¶ͽ¬ǡ(csv)
#
#  Υǡ
#  Useage ./mk_csv_real_yetm.pl TABLE_FILE AREA_NUM WF_NUM -t YYMMDDHHmm\n YYMMDDHHmm:JST
#  -t ץǻ򤷤ʤϡǿǽ
#
#####################################################################
use Time::Local;

$TABLE = $ARGV[0];
$AREA_NUM = $ARGV[1];
$POINT_NUM = $ARGV[2];
require "$TABLE";

use Getopt::Long;
use Time::Local;
$Getopt::Long::ignorecase=undef;
GetOptions('t=s');

#######    ###################
if( $opt_t ne "" && length($opt_t)!=10 ){
   die "Usage ./mk_csv_real_yetm.pl TABLE_FILE AREA_NUM WF_NUM -t YYMMDDHHmm\n YYMMDDHHmm:JST\n";
}elsif( length( $opt_t ) == 10 ){
    $jyear4=1*substr($opt_t,0,2)+2000;
    $jyear2=1*substr($opt_t,0,2);
    $jmonth =1*substr($opt_t,2,2);
    $jday =1*substr($opt_t,4,2);
    $jhour=1*substr($opt_t,6,2);
    $jmin=1*substr($opt_t,8,2);
    $jsec=0;
    $now_t = timelocal($jsec,$jmin,$jhour,$jday,$jmonth-1,$jyear4);
}else{
    $now_t = time();
}


#----  ߻ -----  
($nsec,$nmin,$nhour,$nmday,$nmon,$nyear,$nwday,$nyday,$nisdist) = localtime($now_t);
$nmon++;
$nyear4 = $nyear + 1900;
$nyear2 = $nyear4 % 100;
$now_ymd = sprintf("%02d%02d%02d",$nyear2,$nmon,$nmday);
$now_ymd0000 = sprintf("%02d%02d%02d0000",$nyear2,$nmon,$nmday);

#---- 1
$p1day_t = $now_t-86400;
($psec,$pmin,$phour,$pmday,$pmon,$pyear,$pwday,$pyday,$pisdist) = localtime($p1day_t);
$pmon++;
$pyear4 = $pyear + 1900;
$pyear2 = $pyear4 % 100;
$p1day_ymd = sprintf("%02d%02d%02d",$pyear2,$pmon,$pmday);

#---- 1
$a1day_t = $now_t+86400;
($asec,$amin,$ahour,$amday,$amon,$ayear,$awday,$ayday,$aisdist) = localtime($a1day_t);
$amon++;
$ayear4 = $ayear + 1900;
$ayear2 = $ayear4 % 100;
$a1day_ymd = sprintf("%02d%02d%02d",$ayear2,$amon,$amday);
$a1day_ymd0000 = sprintf("%02d%02d%02d0000",$ayear2,$amon,$amday);

#---- 2
$a2day_t = $now_t+(2*86400);
($a2sec,$a2min,$a2hour,$a2mday,$a2mon,$a2year,$a2wday,$a2yday,$a2isdist) = localtime($a2day_t);
$a2mon++;
$a2year4 = $a2year + 1900;
$a2year2 = $a2year4 % 100;
$a2day_ymd = sprintf("%02d%02d%02d",$a2year2,$a2mon,$a2mday);
$a2day_ymd0000 = sprintf("%02d%02d%02d0000",$a2year2,$a2mon,$a2mday);


######################################
## Open Input data 
######################################
print "INDATA = $REAL_DSET_File\n";
open(IN,"<$REAL_DSET_File");
  @indata = <IN>;
close(IN);

######################################
## Open Output data
######################################
open(OUT1,">$CSVFile_Yesterday");
# open(OUT2,">$CSVFile_Today");
open(OUT3,">$CSVFile_Tomorrow");

foreach $line ( @indata ) {
  chomp($line);
  @buf = split(/,/,$line);
  $ymd = sprintf("%02d%02d%02d",$buf[0],$buf[1],$buf[2]);
  $ymdhm = sprintf("%02d%02d%02d%02d%02d",$buf[0],$buf[1],$buf[2],$buf[3],$buf[4]);
  if ( $ymd eq $p1day_ymd ) {
    printf OUT1 ("%04d/%02d/%02d %02d:%02d,",$pyear4,$buf[1],$buf[2],$buf[3],$buf[4]);
    printf OUT1 "$buf[5],$buf[6],$buf[7],$buf[8],$buf[9],$buf[10],$buf[11],$buf[12],$buf[13],$buf[14],$buf[15],$buf[16]\n";
  }
  if ( $ymdhm eq $now_ymd0000 ) {
    printf OUT1 ("%04d/%02d/%02d 24:00,",$pyear4,$pmon,$pmday);
    printf OUT1 "$buf[5],$buf[6],$buf[7],$buf[8],$buf[9],$buf[10],$buf[11],$buf[12],$buf[13],$buf[14],$buf[15],$buf[16]\n";
  }
  if ( $ymd eq $a1day_ymd ) {
    printf OUT3 ("%04d/%02d/%02d %02d:%02d,",$ayear4,$buf[1],$buf[2],$buf[3],$buf[4]);
    printf OUT3 "$buf[5],$buf[6],$buf[7],$buf[8],$buf[9],$buf[10],$buf[11],$buf[12],$buf[13],$buf[14],$buf[15],$buf[16]\n";
  }
  if ( $ymdhm eq $a2day_ymd0000 ) {
    printf OUT3 ("%04d/%02d/%02d 24:00,",$a2year4,$amon,$amday);
    printf OUT3 "$buf[5],$buf[6],$buf[7],$buf[8],$buf[9],$buf[10],$buf[11],$buf[12],$buf[13],$buf[14],$buf[15],$buf[16]\n";
  }
}

close(OUT1);
# close(OUT2);
close(OUT3);

exit;
