#!/usr/bin/perl
#=====================================================
# NEDO Platform page 
#=====================================================
#        M A I N
#=====================================================

use Time::Local;
use CGI;
require './Nedo_platform.ph';
require './Platform_lib.pl';

#---------------------------
#    ɽꥢ/WFå
#---------------------------
$AreaFlg = 0;
open (PP,"<$WF_POINT_TAB");
while ($line = <PP>) {
  @buf=();
  chomp($line);
  if ( $line =~ /^#/ ) { next;}
  @buf = split(/,/,$line);
  if ( $buf[1] =~ /A/ ) { 
     $AreaFlg = 1; 
     last;
  } 
}
close(PP);
  
#------------------------------------------
#--  AreaͭȤʤǽʬ
#------------------------------------------
if ( $AreaFlg == 1) {

   #---------------------
   #    HTML 
   #---------------------
   $HTML_TAB = sprintf("wf_html_INI.tab");

   #-----------------
   #    OutPut
   #-----------------

   ####   Write Header  ####
   print "Content-Type: text/html\n\n";

   open (IN,"<$HTML_TAB");
   while ($line = <IN>) {

       if (( $line =~ /#WF_NUM#/ )or( $line =~ /#AW_CODE#/ )or( $line =~ /#AREA_NUM#/ )or( $line =~ /#CNT_NUM#/ )or( $line =~ /#S_FLG#/ )){
          $line =~ s/#WF_NUM#/$WF_NUM/g;
          $line =~ s/#AW_CODE#/$AW_CODE/g;
          $line =~ s/#AREA_NUM#/$AREA_NUM/g;
          $line =~ s/#CNT_NUM#/$CNT_NUM/g;
          $line =~ s/#S_FLG#/$S_FLG/g;
          print "$line"; 
       } else {
          print "$line";
       }

   } #while
   close(IN);

} else {

   #--------------------
   #    Set Initial
   #--------------------
   if (( $AW_CODE eq "") or ( $AW_CODE ne "A" and $AW_CODE ne "W")) { $AW_CODE = 9999; }
   if ( $AREA_NUM eq "" ) { $AREA_NUM = 9999; }
   if ( $WF_NUM eq "" ) { $WF_NUM = 9999; }
   if ( $CNT_NUM eq "" ) { $CNT_NUM = 9999; }
   if ( $S_FLG eq "" ) { $S_FLG = 0; }

   #---------------------
   #    HTML 
   #---------------------
   if ( $AREA_NUM == 9999 or $WF_NUM == 9999  or  $CNT_NUM == 9999 ) {
      open(TAB,"<$WF_POINT_TAB");
      while ($tline = <TAB>) {
        chomp($tline);
        $s1 = substr($tline,0,1);
        if ( $s1 eq "#" ) { next; }
        @tdat = split(/,/,$tline);
        $AW_CODE_tmp = $tdat[1];
        $AREA_NUM = $tdat[2];
        $WF_NUM = $tdat[3];
        if ( $AW_CODE == 9999 ) {
           if ( $AW_CODE_tmp ne "A" and $AW_CODE_tmp ne "W") { next; }
           $AW_CODE = $AW_CODE_tmp;
           last;
        } elsif ( $AW_CODE eq "A" ) {
           if($AW_CODE_tmp eq "A" ) {
               $AW_CODE = $AW_CODE_tmp;
               last;
           }
        } elsif ( $AW_CODE eq "W" ) {
           if($AW_CODE_tmp eq "W" ) {
               $AW_CODE = $AW_CODE_tmp;
               last;
           }
        } else {
           next;
        }
      }
      close(TAB);
      $CNT_NUM = 111;
      $AWC_SET_FLG = 1;
      $HTML_TAB = sprintf("wf_html_base_Nchg.tab");
   }else{
      $AWC_SET_FLG = 0;
      $HTML_TAB = sprintf("wf_html_base_Nchg.tab");
   }

   #-- ̾ʳΥǡѥ
   if ( $S_FLG == 1 ) { $DAT_PATH = $DAT_PATH_SHUUDAN; }
   if ( $S_FLG == 2 ) { $DAT_PATH = $DAT_PATH_KANI; }

   #-----------------
   #    OutPut
   #-----------------

   ####   Write Header  ####
   print "Content-Type: text/html\n\n";

   open (IN,"<$HTML_TAB");
   while ($line = <IN>) {

       #--- ȯŽץ
       if (( $line =~ /##POINT_SELECT_PART##/) and ($AWC_SET_FLG == 0)) {
           Write_Select_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
       } elsif (( $line =~ /##POINT_SELECT_PART##/) and ($AWC_SET_FLG == 1)) {
           Write_Select_WF($AW_CODE,9999,9999,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
       } elsif (( $line =~ /#WF_NUM#/ )or( $line =~ /#AW_CODE#/ )or( $line =~ /#AREA_NUM#/ )or($line =~ /#S_FLG#/ )) {
           $line =~ s/#AW_CODE#/$AW_CODE/g;
           $line =~ s/#AREA_NUM#/$AREA_NUM/g;
           $line =~ s/#WF_NUM#/$WF_NUM/g;
           $line =~ s/#S_FLG#/$S_FLG/g;
           print "$line";
       } elsif ( $line =~ /##CONTENTS_DISPLAY_PART##/ ) {
           Write_Content_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$DAT_PATH,$S_FLG);
       } elsif ( $line =~ /##SHUUDAN_F##/ ) {
           if ( $S_FLG == 0 ) {
             $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">̾<\/font>/g;
           } elsif ( $S_FLG == 1 ) {
             $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">ʽġ<\/font>/g;
           } else {
             $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">ʴʰס<\/font>/g;
           }
           print "$line";
       } else {
           print "$line";
       }

   } #while
   close(IN);

}

exit;

#=====================================================
#        E N D   M A I N
#=====================================================

