#!/usr/bin/perl
#==============================
# NEDO Platform page 
#   1st.2007.03.23 T.Yokotsuka
#   2nd.2007.07.11 T.Yokotsuka
#   3rd.2007.08.15 T.Yokotsuka
#------------------------------
#=====================================================
#        M A I N
#=====================================================

use Time::Local;
use CGI;
require './Nedo_platform.ph';
require './Platform_lib.pl';

$query = new CGI;
$AW_CODE = $query->param( "AW" );
$AREA_NUM = $query->param( "AREA" );
$WF_NUM = $query->param( "WF" );
$CNT_NUM = $query->param( "CNT" );
$S_FLG = $query->param( "SFL" );

#---  DATA PATH Setting ------
$DAT_PATH = $DAT_PATH_std;
#--------------------
#    Set Initial 
#--------------------
if (( $AW_CODE eq "") or ( $AW_CODE ne "A" and $AW_CODE ne "W")) { $AW_CODE = 9999; }
if ( $AREA_NUM eq "" ) { $AREA_NUM = 9999; }
if ( $WF_NUM eq "" ) { $WF_NUM = 9999; }
if ( $CNT_NUM eq "" ) { $CNT_NUM = 9999; }
if ( $S_FLG eq "" ) { $S_FLG = 0; }

#---------------------
#    HTML 
#---------------------
if ( $AREA_NUM == 9999 or $WF_NUM == 9999  or  $CNT_NUM == 9999 ) {
   open(TAB,"<$WF_POINT_TAB");
   while ($tline = <TAB>) {
     chomp($tline);
     $s1 = substr($tline,0,1);
     if ( $s1 eq "#" ) { next; }
     @tdat = split(/,/,$tline);
     $AW_CODE_tmp = $tdat[1];
     $AREA_NUM = $tdat[2];
     $WF_NUM = $tdat[3];
     if ( $AW_CODE == 9999 ) { 
        if ( $AW_CODE_tmp ne "A" and $AW_CODE_tmp ne "W") { next; }
        $AW_CODE = $AW_CODE_tmp;
        last;
     } elsif ( $AW_CODE eq "A" ) {
        if($AW_CODE_tmp eq "A" ) {
            $AW_CODE = $AW_CODE_tmp;
            last;
        }
     } elsif ( $AW_CODE eq "W" ) {
        if($AW_CODE_tmp eq "W" ) {
            $AW_CODE = $AW_CODE_tmp;
            last;
        }
     } else {
        next;
     }
   } 
   close(TAB);
   $CNT_NUM = 111;
   $AWC_SET_FLG = 1;
   $HTML_TAB = sprintf("wf_html_base.tab");
}else{
   $AWC_SET_FLG = 0; 
   $HTML_TAB = sprintf("wf_html_base.tab");
}

#-- ǡѥ
if ( $S_FLG == 1 ) { $DAT_PATH = $DAT_PATH_SHUUDAN; }
if ( $S_FLG == 2 ) { $DAT_PATH = $DAT_PATH_KANI; }

#-----------------
#    OutPut
#-----------------

####   Write Header  ####
print "Content-Type: text/html\n\n";


open (IN,"<$HTML_TAB");
while ($line = <IN>) {

    #--- ȯŽץ 
    if (( $line =~ /##POINT_SELECT_PART##/) and ($AWC_SET_FLG == 0)) {
	Write_Select_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
    } elsif (( $line =~ /##POINT_SELECT_PART##/) and ($AWC_SET_FLG == 1)) {
        Write_Select_WF($AW_CODE,9999,9999,$CNT_NUM,$WF_POINT_TAB,$S_FLG);
    } elsif (( $line =~ /#WF_NUM#/ )or( $line =~ /#AW_CODE#/ )or( $line =~ /#AREA_NUM#/ )or( $line =~ /#S_FLG#/ )) {
        $line =~ s/#AW_CODE#/$AW_CODE/g;
        $line =~ s/#AREA_NUM#/$AREA_NUM/g;
        $line =~ s/#WF_NUM#/$WF_NUM/g;
        $line =~ s/#S_FLG#/$S_FLG/g;
        print "$line"; 
    } elsif ( $line =~ /##CONTENTS_DISPLAY_PART##/ ) {

        #-- ⥸塼ؤ
        if ( $CNT_NUM eq "501") {
	  Write_Content501_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$DAT_PATH,$S_FLG);
        #-- ꥢ륿ͽ¬
        } elsif (($CNT_NUM eq "211")or($CNT_NUM eq "212")or($CNT_NUM eq "221")or($CNT_NUM eq "222")or($CNT_NUM eq "311")or($CNT_NUM eq "312")or($CNT_NUM eq "313")or($CNT_NUM eq "314")or($CNT_NUM eq "321")) { 
          Write_Content_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$DAT_PATH_std,$S_FLG);
        #-- ¾ɾ̤ʤɡ
        } else {
          Write_Content_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$DAT_PATH,$S_FLG);
        }

    } elsif ( $line =~ /##SHUUDAN_F##/ ) {
        if ( $S_FLG == 0 ) {
	  $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">̾<\/font>/g;
        } elsif ( $S_FLG == 1 ) {
          $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">ʽġ<\/font>/g;
        } else {
	  $line =~ s/##SHUUDAN_F##/<font color=\"#E50404\">ʴʰס<\/font>/g;
        }
	print "$line";
    } else {
        print "$line";
    }

}
close(IN);

exit;

#=====================================================
#        E N D   M A I N
#=====================================================
